# ChatCompletionResponseMessage

A chat completion message generated by the model.

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**content** | **str** | The contents of the message. | 
**refusal** | **str** | The refusal message generated by the model. | 
**role** | **str** | The role of the author of this message. | 
**tool_calls** | [**List[ChatCompletionMessageToolCall]**](ChatCompletionMessageToolCall.md) |  | [optional] 
**gabber** | [**ChatCompletionResponseMessageGabber**](ChatCompletionResponseMessageGabber.md) |  | [optional] 

## Example

```python
from gabber.generated.gabber.models.chat_completion_response_message import ChatCompletionResponseMessage

# TODO update the JSON string below
json = "{}"
# create an instance of ChatCompletionResponseMessage from a JSON string
chat_completion_response_message_instance = ChatCompletionResponseMessage.from_json(json)
# print the JSON string representation of the object
print(ChatCompletionResponseMessage.to_json())

# convert the object into a dict
chat_completion_response_message_dict = chat_completion_response_message_instance.to_dict()
# create an instance of ChatCompletionResponseMessage from a dict
chat_completion_response_message_from_dict = ChatCompletionResponseMessage.from_dict(chat_completion_response_message_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


