# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from gabber.generated.gabber.models.tts_websocket_request_message import TTSWebsocketRequestMessage
from gabber.generated.gabber.models.tts_websocket_response_message import TTSWebsocketResponseMessage
from gabber.generated.gabber.models.webhook_message import WebhookMessage
from typing import Optional, Set
from typing_extensions import Self

class DummyGet200Response(BaseModel):
    """
    DummyGet200Response
    """ # noqa: E501
    webhook_message: Optional[WebhookMessage] = None
    tts_websocket_request_message: Optional[TTSWebsocketRequestMessage] = None
    tts_websocket_response_message: Optional[TTSWebsocketResponseMessage] = None
    __properties: ClassVar[List[str]] = ["webhook_message", "tts_websocket_request_message", "tts_websocket_response_message"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DummyGet200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of webhook_message
        if self.webhook_message:
            _dict['webhook_message'] = self.webhook_message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tts_websocket_request_message
        if self.tts_websocket_request_message:
            _dict['tts_websocket_request_message'] = self.tts_websocket_request_message.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tts_websocket_response_message
        if self.tts_websocket_response_message:
            _dict['tts_websocket_response_message'] = self.tts_websocket_response_message.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DummyGet200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "webhook_message": WebhookMessage.from_dict(obj["webhook_message"]) if obj.get("webhook_message") is not None else None,
            "tts_websocket_request_message": TTSWebsocketRequestMessage.from_dict(obj["tts_websocket_request_message"]) if obj.get("tts_websocket_request_message") is not None else None,
            "tts_websocket_response_message": TTSWebsocketResponseMessage.from_dict(obj["tts_websocket_response_message"]) if obj.get("tts_websocket_response_message") is not None else None
        })
        return _obj


