# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List
from gabber.generated.gabber.models.realtime_session_general_config import RealtimeSessionGeneralConfig
from gabber.generated.gabber.models.realtime_session_generative_config_create import RealtimeSessionGenerativeConfigCreate
from gabber.generated.gabber.models.realtime_session_input_config import RealtimeSessionInputConfig
from gabber.generated.gabber.models.realtime_session_output_config import RealtimeSessionOutputConfig
from typing import Optional, Set
from typing_extensions import Self

class RealtimeSessionConfigCreate(BaseModel):
    """
    RealtimeSessionConfigCreate
    """ # noqa: E501
    general: RealtimeSessionGeneralConfig
    input: RealtimeSessionInputConfig
    generative: RealtimeSessionGenerativeConfigCreate
    output: RealtimeSessionOutputConfig
    __properties: ClassVar[List[str]] = ["general", "input", "generative", "output"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RealtimeSessionConfigCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of general
        if self.general:
            _dict['general'] = self.general.to_dict()
        # override the default output from pydantic by calling `to_dict()` of input
        if self.input:
            _dict['input'] = self.input.to_dict()
        # override the default output from pydantic by calling `to_dict()` of generative
        if self.generative:
            _dict['generative'] = self.generative.to_dict()
        # override the default output from pydantic by calling `to_dict()` of output
        if self.output:
            _dict['output'] = self.output.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RealtimeSessionConfigCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "general": RealtimeSessionGeneralConfig.from_dict(obj["general"]) if obj.get("general") is not None else None,
            "input": RealtimeSessionInputConfig.from_dict(obj["input"]) if obj.get("input") is not None else None,
            "generative": RealtimeSessionGenerativeConfigCreate.from_dict(obj["generative"]) if obj.get("generative") is not None else None,
            "output": RealtimeSessionOutputConfig.from_dict(obj["output"]) if obj.get("output") is not None else None
        })
        return _obj


