# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RealtimeSessionOutputConfig(BaseModel):
    """
    Configuration for the output of the RealtimeSession.
    """ # noqa: E501
    stream_transcript: StrictBool = Field(description="Whether to stream agent spoken transcript or send full transcript when it's available all at once.")
    speech_synthesis_enabled: StrictBool = Field(description="Whether to enable speech synthesis for the RealtimeSession.")
    answer_message: Optional[StrictStr] = Field(default=None, description="The message for the agent to speak first when the human joins. If exluded the agent will not speak first.")
    __properties: ClassVar[List[str]] = ["stream_transcript", "speech_synthesis_enabled", "answer_message"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RealtimeSessionOutputConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RealtimeSessionOutputConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "stream_transcript": obj.get("stream_transcript"),
            "speech_synthesis_enabled": obj.get("speech_synthesis_enabled") if obj.get("speech_synthesis_enabled") is not None else True,
            "answer_message": obj.get("answer_message")
        })
        return _obj


