# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Session(BaseModel):
    """
    Session
    """ # noqa: E501
    created_at: datetime
    ended_at: Optional[datetime] = None
    id: StrictStr
    livekit_room: StrictStr
    metadata: Optional[Any]
    persona: StrictStr
    project: StrictStr
    scenario: StrictStr
    llm: Optional[StrictStr] = None
    state: StrictStr
    voice_override: Optional[StrictStr] = None
    time_limit_s: StrictInt
    __properties: ClassVar[List[str]] = ["created_at", "ended_at", "id", "livekit_room", "metadata", "persona", "project", "scenario", "llm", "state", "voice_override", "time_limit_s"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ended', 'in_progress', 'not_started']):
            raise ValueError("must be one of enum values ('ended', 'in_progress', 'not_started')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Session from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if metadata (nullable) is None
        # and model_fields_set contains the field
        if self.metadata is None and "metadata" in self.model_fields_set:
            _dict['metadata'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Session from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "ended_at": obj.get("ended_at"),
            "id": obj.get("id"),
            "livekit_room": obj.get("livekit_room"),
            "metadata": obj.get("metadata"),
            "persona": obj.get("persona"),
            "project": obj.get("project"),
            "scenario": obj.get("scenario"),
            "llm": obj.get("llm"),
            "state": obj.get("state"),
            "voice_override": obj.get("voice_override"),
            "time_limit_s": obj.get("time_limit_s")
        })
        return _obj


