# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SessionStartRequestOneOf1(BaseModel):
    """
    SessionStartRequestOneOf1
    """ # noqa: E501
    time_limit_s: Optional[StrictInt] = None
    voice_override: Optional[StrictStr] = None
    llm: Optional[StrictStr] = None
    scenario: Optional[StrictStr] = None
    persona: Optional[StrictStr] = None
    save_messages: Optional[StrictBool] = Field(default=True, description="save session messages")
    extra: Optional[Dict[str, Any]] = Field(default=None, description="reserved for internal use", alias="_extra")
    __properties: ClassVar[List[str]] = ["time_limit_s", "voice_override", "llm", "scenario", "persona", "save_messages", "_extra"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SessionStartRequestOneOf1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SessionStartRequestOneOf1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "time_limit_s": obj.get("time_limit_s"),
            "voice_override": obj.get("voice_override"),
            "llm": obj.get("llm"),
            "scenario": obj.get("scenario"),
            "persona": obj.get("persona"),
            "save_messages": obj.get("save_messages") if obj.get("save_messages") is not None else True,
            "_extra": obj.get("_extra")
        })
        return _obj


