# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from gabber.generated.gabber.models.persona import Persona
from gabber.generated.gabber.models.scenario import Scenario
from gabber.generated.gabber.models.session import Session
from gabber.generated.gabber.models.session_start_response_connection_details import SessionStartResponseConnectionDetails
from typing import Optional, Set
from typing_extensions import Self

class SessionStartResponse(BaseModel):
    """
    SessionStartResponse
    """ # noqa: E501
    session: Session
    persona: Optional[Persona] = None
    scenario: Optional[Scenario] = None
    connection_details: SessionStartResponseConnectionDetails
    __properties: ClassVar[List[str]] = ["session", "persona", "scenario", "connection_details"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SessionStartResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of session
        if self.session:
            _dict['session'] = self.session.to_dict()
        # override the default output from pydantic by calling `to_dict()` of persona
        if self.persona:
            _dict['persona'] = self.persona.to_dict()
        # override the default output from pydantic by calling `to_dict()` of scenario
        if self.scenario:
            _dict['scenario'] = self.scenario.to_dict()
        # override the default output from pydantic by calling `to_dict()` of connection_details
        if self.connection_details:
            _dict['connection_details'] = self.connection_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SessionStartResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "session": Session.from_dict(obj["session"]) if obj.get("session") is not None else None,
            "persona": Persona.from_dict(obj["persona"]) if obj.get("persona") is not None else None,
            "scenario": Scenario.from_dict(obj["scenario"]) if obj.get("scenario") is not None else None,
            "connection_details": SessionStartResponseConnectionDetails.from_dict(obj["connection_details"]) if obj.get("connection_details") is not None else None
        })
        return _obj


