# coding: utf-8

"""
    Session API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RealtimeLivekitAttachRequestConfigGenerative(BaseModel):
    """
    Configuration for the generative AI in the RealtimeSession.
    """ # noqa: E501
    llm: StrictStr = Field(description="The LLM to use for the RealtimeSession.")
    voice_override: Optional[StrictStr] = Field(default=None, description="The voice to use for the RealtimeSession.")
    persona: Optional[StrictStr] = Field(default=None, description="The persona to use for the RealtimeSession.")
    scenario: Optional[StrictStr] = Field(default=None, description="The scenario to use for the RealtimeSession.")
    context: Optional[StrictStr] = Field(default=None, description="The context to use for the RealtimeSession. If unspecified, a new context will be created.")
    tool_definitions: Optional[List[StrictStr]] = Field(default=None, description="The tool definitions to use for the generative AI.")
    extra: Optional[Dict[str, Any]] = Field(default=None, description="Extra configuration for the generative AI. Usually this is for internal purposes.", alias="_extra")
    __properties: ClassVar[List[str]] = ["llm", "voice_override", "persona", "scenario", "context", "tool_definitions", "_extra"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RealtimeLivekitAttachRequestConfigGenerative from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RealtimeLivekitAttachRequestConfigGenerative from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "llm": obj.get("llm"),
            "voice_override": obj.get("voice_override"),
            "persona": obj.get("persona"),
            "scenario": obj.get("scenario"),
            "context": obj.get("context"),
            "tool_definitions": obj.get("tool_definitions"),
            "_extra": obj.get("_extra")
        })
        return _obj


