# gabber.generated.gabber-internal
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The `gabber.generated.gabber_internal` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.12.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 1.25.3, < 3.0.0
* python-dateutil >= 2.8.2
* aiohttp >= 3.8.4
* aiohttp-retry >= 2.8.3
* pydantic >= 2
* typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with gabber.generated.gabber-internal,
you can run the following:

```python

import gabber.generated.gabber_internal
from gabber.generated.gabber_internal.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = gabber.generated.gabber_internal.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
async with gabber.generated.gabber_internal.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = gabber.generated.gabber_internal.DummyApi(api_client)

    try:
        # Dummy endpoint
        api_response = await api_instance.dummy()
        print("The response of DummyApi->dummy:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DummyApi->dummy: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DummyApi* | [**dummy**](gabber/generated/gabber_internal/docs/DummyApi.md#dummy) | **GET** /v1/internal/dummy | Dummy endpoint
*PhoneApi* | [**get_phone_attachment**](gabber/generated/gabber_internal/docs/PhoneApi.md#get_phone_attachment) | **GET** /v1/internal/phone/get_attachment | Get phone attachment
*RealtimeApi* | [**attach_livekit_room**](gabber/generated/gabber_internal/docs/RealtimeApi.md#attach_livekit_room) | **POST** /v1/internal/realtime/livekit/attach | Create realtime session from livekit room
*RealtimeApi* | [**realtime_session_time_limit_exceeded**](gabber/generated/gabber_internal/docs/RealtimeApi.md#realtime_session_time_limit_exceeded) | **POST** /v1/internal/realtime/{session}/time_limit_exceeded | Realtime session time limit exceeded
*RealtimeApi* | [**update_realtime_session_state**](gabber/generated/gabber_internal/docs/RealtimeApi.md#update_realtime_session_state) | **POST** /v1/internal/realtime/{session}/update_state | Update realtime session state
*UserApi* | [**get_user**](gabber/generated/gabber_internal/docs/UserApi.md#get_user) | **GET** /v1/internal/user | Get user by id
*UserApi* | [**login_google_user**](gabber/generated/gabber_internal/docs/UserApi.md#login_google_user) | **POST** /v1/internal/user/login_google_user | Login a google user


## Documentation For Models

 - [AttachLivekitRoom200Response](gabber/generated/gabber_internal/docs/AttachLivekitRoom200Response.md)
 - [AttachLivekitRoom200ResponseConfig](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfig.md)
 - [AttachLivekitRoom200ResponseConfigGeneral](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGeneral.md)
 - [AttachLivekitRoom200ResponseConfigGenerative](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerative.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContext](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContext.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerContentInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerContentInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerContentInnerOneOf](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerContentInnerOneOf.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerToolCallsInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerToolCallsInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerToolCallsInnerFunction](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeContextLatestMessagesInnerToolCallsInnerFunction.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeLlm](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeLlm.md)
 - [AttachLivekitRoom200ResponseConfigGenerativePersona](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativePersona.md)
 - [AttachLivekitRoom200ResponseConfigGenerativePersonaTagsInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativePersonaTagsInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeScenario](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeScenario.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettings](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettings.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettingsDestination](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettingsDestination.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettingsDestinationOneOf](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerCallSettingsDestinationOneOf.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerParametersInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeToolDefinitionsInnerParametersInner.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeVoiceOverride](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeVoiceOverride.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeVoiceOverridePricing](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeVoiceOverridePricing.md)
 - [AttachLivekitRoom200ResponseConfigGenerativeVoiceOverrideTagsInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigGenerativeVoiceOverrideTagsInner.md)
 - [AttachLivekitRoom200ResponseConfigInput](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigInput.md)
 - [AttachLivekitRoom200ResponseConfigOutput](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseConfigOutput.md)
 - [AttachLivekitRoom200ResponseDataInner](gabber/generated/gabber_internal/docs/AttachLivekitRoom200ResponseDataInner.md)
 - [Dummy200Response](gabber/generated/gabber_internal/docs/Dummy200Response.md)
 - [InlineObject](gabber/generated/gabber_internal/docs/InlineObject.md)
 - [LoginGoogleUser200Response](gabber/generated/gabber_internal/docs/LoginGoogleUser200Response.md)
 - [LoginGoogleUserRequest](gabber/generated/gabber_internal/docs/LoginGoogleUserRequest.md)
 - [PhoneConnection](gabber/generated/gabber_internal/docs/PhoneConnection.md)
 - [PhoneNumber](gabber/generated/gabber_internal/docs/PhoneNumber.md)
 - [PhoneNumberAttachment](gabber/generated/gabber_internal/docs/PhoneNumberAttachment.md)
 - [PhoneNumberCapabilities](gabber/generated/gabber_internal/docs/PhoneNumberCapabilities.md)
 - [PhoneNumberType](gabber/generated/gabber_internal/docs/PhoneNumberType.md)
 - [RealtimeLivekitAttachRequest](gabber/generated/gabber_internal/docs/RealtimeLivekitAttachRequest.md)
 - [RealtimeLivekitAttachRequestConfig](gabber/generated/gabber_internal/docs/RealtimeLivekitAttachRequestConfig.md)
 - [RealtimeLivekitAttachRequestConfigGenerative](gabber/generated/gabber_internal/docs/RealtimeLivekitAttachRequestConfigGenerative.md)
 - [UpdateRealtimeSessionStateRequest](gabber/generated/gabber_internal/docs/UpdateRealtimeSessionStateRequest.md)
 - [User](gabber/generated/gabber_internal/docs/User.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: x-internal-service-secret
- **Location**: HTTP header

<a id="HumanId"></a>
### HumanId

- **Type**: API key
- **API key parameter name**: x-human-id
- **Location**: HTTP header


## Author




