# coding: utf-8

"""
    Gabber API Reference

    The Gabber API is a set of APIs that allow you to interact with the Gabber platform.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, Dict, List, Optional
from gabber.generated.gabber.models.tts_websocket_request_message_push_text_payload import TTSWebsocketRequestMessagePushTextPayload
from gabber.generated.gabber.models.tts_websocket_request_message_start_session_payload import TTSWebsocketRequestMessageStartSessionPayload
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

TTSWEBSOCKETREQUESTMESSAGEPAYLOAD_ONE_OF_SCHEMAS = ["TTSWebsocketRequestMessagePushTextPayload", "TTSWebsocketRequestMessageStartSessionPayload", "object"]

class TTSWebsocketRequestMessagePayload(BaseModel):
    """
    TTSWebsocketRequestMessagePayload
    """
    # data type: TTSWebsocketRequestMessageStartSessionPayload
    oneof_schema_1_validator: Optional[TTSWebsocketRequestMessageStartSessionPayload] = None
    # data type: TTSWebsocketRequestMessagePushTextPayload
    oneof_schema_2_validator: Optional[TTSWebsocketRequestMessagePushTextPayload] = None
    # data type: object
    oneof_schema_3_validator: Optional[Dict[str, Any]] = None
    actual_instance: Optional[Union[TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object]] = None
    one_of_schemas: Set[str] = { "TTSWebsocketRequestMessagePushTextPayload", "TTSWebsocketRequestMessageStartSessionPayload", "object" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = TTSWebsocketRequestMessagePayload.model_construct()
        error_messages = []
        match = 0
        # validate data type: TTSWebsocketRequestMessageStartSessionPayload
        if not isinstance(v, TTSWebsocketRequestMessageStartSessionPayload):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TTSWebsocketRequestMessageStartSessionPayload`")
        else:
            match += 1
        # validate data type: TTSWebsocketRequestMessagePushTextPayload
        if not isinstance(v, TTSWebsocketRequestMessagePushTextPayload):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TTSWebsocketRequestMessagePushTextPayload`")
        else:
            match += 1
        # validate data type: object
        try:
            instance.oneof_schema_3_validator = v
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in TTSWebsocketRequestMessagePayload with oneOf schemas: TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in TTSWebsocketRequestMessagePayload with oneOf schemas: TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into TTSWebsocketRequestMessageStartSessionPayload
        try:
            instance.actual_instance = TTSWebsocketRequestMessageStartSessionPayload.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TTSWebsocketRequestMessagePushTextPayload
        try:
            instance.actual_instance = TTSWebsocketRequestMessagePushTextPayload.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.oneof_schema_3_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.oneof_schema_3_validator
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into TTSWebsocketRequestMessagePayload with oneOf schemas: TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into TTSWebsocketRequestMessagePayload with oneOf schemas: TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], TTSWebsocketRequestMessagePushTextPayload, TTSWebsocketRequestMessageStartSessionPayload, object]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


